<?PHP

/**
*	Datenbank Zugangsdaten
*/
define("DB_HOST","localhost"); 		// MySQL Hostname
define("DB_NAME","db_name"); 	// MySQL Datenbankname
define("DB_USER","db_user"); // MySQL Benutzername
define("DB_PASS","db_passwd"); 		// MySQL Passwort
$db['table']	=	'rijndael';				// MySQL Tabellenname


$dbCon = @MYSQL_CONNECT(DB_HOST,DB_USER,DB_PASS) or die("Datenbank momentan nicht erreichbar");
$db_check = @MYSQL_SELECT_DB(DB_NAME) or die("Datenbank momentan nicht erreichbar");

$error = false;

if(isset($_POST['decode']))
{
	if(empty($_POST['password']))
	{
		$error = true;
		$decodemessage = 'Bitte geben Sie ein Passwort ein<br>';
	}
	
	if(!$error)
	{
		$id = $_POST['decode'] + 0;
		$sqlDecrypt = 	"SELECT id, textaes, block,
						DATE_FORMAT(encrypt,'%m.%m.%Y %H:%i:%s') AS encrypt,
						DATE_FORMAT(decrypt,'%m.%m.%Y %H:%i:%s') AS decrypt,
						DATE_FORMAT(decryptError,'%m.%m.%Y %H:%i:%s') AS decryptError,
						ivTag, md5	FROM " . $db['table'] . " WHERE id = $id";
		$status = @mysql_query($sqlDecrypt);
		
		if(@mysql_num_rows($status) == "1")
		{
			$infoText['bit']			= @mysql_result($status,0,"block") . ' Bit';
			$infoText['encrypt']		= @mysql_result($status,0,"encrypt");
			$infoText['decrypt']		= @mysql_result($status,0,"decrypt");
			$infoText['decryptError']	= @mysql_result($status,0,"decryptError");
			$infoText['md5']			= @mysql_result($status,0,"md5");
			$infoText['content']		= @mysql_result($status,0,"textaes");
			$infoText['iv']				= @mysql_result($status,0,"ivTag");
			
			include_once("rijndael.inc.php");
			
			$decrypted = decryptAES($infoText['content'],$infoText['iv'],$_POST['password'],$infoText['bit']);
			
			switch ($_POST['job']) 
			{
				case 2:
					// IV-Tag Download
   					if(checkDecrypt($decrypted,$infoText['md5']))
						sendIV($infoText['iv'],$infoText['md5'],$infoText['bit']);
   					break;
				case 3:
					// Rijndael Download
   					if(checkDecrypt($decrypted,$infoText['md5']))
   						sendEncrypt($infoText['content'],$infoText['md5']);
					break;
				case 4:
					// Lschen
   					if(checkDecrypt($decrypted,$infoText['md5']))
   					{
   						$sqlDelete = @mysql_query("DELETE FROM " . $db['table'] . " WHERE id = $id"); 
   						unset($decrypted);   						
   					}
   					break;
				default:
					// Entschlsseln
   					$decodemessage = checkDecrypt($decrypted,$infoText['md5'],$id,true);
			}
			
		}
		else
		{
			$decodemessage = 'Keine Daten vorhanden!<br>';
		}
	}
	
}

if(isset($_POST['typ']))
{
	if(empty($_POST['password']))
	{
		$error = true;
		$message .= 'Bitte geben Sie ein Passwort ein<br>';
	}
	
	if(empty($_POST['info']))
	{
		$error = true;
		$message .= 'Bitte geben Sie einen Infotext ein<br>';
	}
	
	if($_POST['password'] != $_POST['passwordCheck'])
	{
		$error = true;
		$message .= 'Passwrter stimmen nicht berein<br>';
	}
	
	if(empty($_POST['textfield']) && $_POST['typ'] == "1")
	{
		$error = true;
		$message .= 'Bitte geben Sie einen Text ein<br>';
	}
	
	if ($_POST['typ'] == "2")
	{
		
		if($_FILES['file']['error'])
		{
			$error = true;
			$message .= 'Bitte geben Sie eine Datei an<br>';
		}
		else
		{
			$filetmp = time() . '.tmp';
			move_uploaded_file($_FILES['file']['tmp_name'], "./$filetmp");
			$content = file_get_contents($filetmp);
			unlink($filetmp);
		}
	}
	
	if(!$error)
	{
		if($_POST['typ'] == "1")
		$content = $_POST['textfield'];
		$password = $_POST['password'];
		$rijndael = $_POST['rijndael'];
		$info = $_POST['info'];
		
		include_once("rijndael.inc.php");
		$enc	=	encryptAES($content,$password,$rijndael);
		
		$decrypted = decryptAES($enc['encrypted'],$enc['iv'],$password,$rijndael);
		
		if(checkDecrypt($decrypted,$enc['md5']))
			insertBase($enc['encrypted'],$enc['iv'],$info,$rijndael,$enc['md5'],$db['table']);
		else
			$message = 'Daten konnten nicht verschlsselt werden!';
		
	}
}

// Holt alle Daten
$sqlShow = @mysql_query("SELECT id, infotext FROM " . $db['table'] . " ORDER BY id");
while($row = @mysql_fetch_row($sqlShow))
{
	$selected = '';
	if($_POST['decode'] == $row[0])
	$selected = 'selected';
	$data .= '<option value="'.$row[0].'" '.$selected.'>'.$row[1].'</option>';
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<!-- DW6 -->
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Untitled Document</title>
<link rel="stylesheet" href="rijndael.css" type="text/css">
</head>
<body> 
<div id="masthead"> 
 
  <h2 id="pageName">SELFPHP - Beispiel Kryptographie Rijndael</h2> 
  <div id="breadCrumb"> 
    <a href="#">Men&uuml; 1</a> / <a href="#">Men&uuml; 2</a> / <a href="#">Men&uuml;
    3</a> /
  </div> 
</div> 
<div id="navBar"> 
  <div id="sectionLinks"> 
   <h3>Mein Untermen&uuml;</h3>
    <ul>
      <li><a href="#">Men&uuml; 1</a></li>
	  <li><a href="#">Men&uuml; 2</a></li>
	  <li><a href="#">Men&uuml; 3</a></li>
	  <li><a href="#">Men&uuml; 4</a></li>	  
    </ul>
  </div> 
</div> 
<!--end navBar div --> 
<div id="headlines"> 
  <h3>Info</h3> 
  <p>
   Verschl&uuml;sselung<br>
  <?PHP echo $infoText['bit']; ?><br>
  <br>
  Verschl&uuml;sselt am<br>
  <?PHP echo $infoText['encrypt']; ?><br>
  <br>
  Zuletzt erfolgreich entschl&uuml;sselt<br>
  <?PHP echo $infoText['decrypt']; ?>
  <br>
  <br>
  Letzte fehlgeschlagene Entschl&uuml;sselung<br>
  <?PHP echo $infoText['decryptError']; ?><br>
</p>
</div> 
<!--end headlines --> 
<div id="content"> 
  <div class="feature"> 
  	<h3>Entschl&uuml;sselung</h3>
	<br>
	Sie k&ouml;nnen hier einen bestehenden veschl&uuml;sselten Text aus der Datenbank wieder
	entschl&uuml;sseln. Weiterhin haben Sie hier die M&ouml;glichkeit, die IV-Tag bzw.
	Rijndael-Datei per Download zu erhalten oder den verschl&uuml;sselten Text zu
	l&ouml;schen. F&uuml;r alle Aufgaben ben&ouml;tigen Sie jeweils das richtige Passwort! Die
	Daten k&ouml;nnen ohne Passwort nicht wieder hergestellt werden.<br>
	<br>
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="errorTable">
      <tr>
        <td><?PHP echo $decodemessage; ?>&nbsp;</td>
      </tr>
    </table>
	<br>
	<form action="rijndael.php" method="post">
	<table width="100%" border="0" cellpadding="3" cellspacing="0" class="text">
	  <tr>
	    <td width="22%">Daten</td>
	    <td width="78%"><select name="decode" id="decode" class="inputField">
          <?PHP echo $data; ?>
        </select></td>
      </tr>
	  <tr>
	    <td width="22%">Aufgabe</td>
	    <td width="78%"><select name="job" id="job" class="inputField">
          <option value="1" <?PHP if($_POST['job'] == 1) echo 'selected'; ?>>Entschl&uuml;sseln</option>
          <option value="2" <?PHP if($_POST['job'] == 2) echo 'selected'; ?>>IV-Tag Datei downloaden</option>
          <option value="3" <?PHP if($_POST['job'] == 3) echo 'selected'; ?>>Rijndael Datei downloaden</option>
		  <option value="4" <?PHP if($_POST['job'] == 4) echo 'selected'; ?>>Daten l&ouml;schen</option>
        </select></td>
      </tr>
	  <tr>
	    <td>Passwort</td>
	    <td><input name="password" type="password" id="password" class="inputField"></td>
      </tr>
	  <tr>
	    <td>Text</td>
	    <td><textarea name="textarea" rows="6"  class="Textfiled"><?PHP echo $decrypted; ?></textarea></td>
      </tr>
	  <tr>
	    <td>&nbsp;</td>
	    <td>&nbsp;</td>
      </tr>
	   <tr>
	    <td>&nbsp;</td>
	    <td><input type="submit" name="Submit" value="Ausf&uuml;hren" class="SendButton">
	    </td>
      </tr>
    </table>
	</form>
	<br>
	<h3>Verschl&uuml;sselung</h3> 
    <p>
     Sie k&ouml;nnen hier entweder einen Text oder den Inhalt einer Datei verschl&uuml;sseln.
       Anhand des Infotextes k&ouml;nnen Sie sp&auml;ter bei der Entschl&uuml;sselung den Datensatz
       ausw&auml;hlen. Weiterhin haben Sie die M&ouml;glichkeit die Verschl&uuml;sselungsst&auml;rke
       (128, 192 oder 256 Bit) einzustellen. Falls Sie das gew&auml;hlte Passwort
       vergessen sollten, so k&ouml;nnen die verschl&uuml;sselten Daten nicht wieder entschl&uuml;sselt
       werden und sind somit f&uuml;r immer verloren.    </p> 
    <table width="100%" border="0" cellspacing="0" cellpadding="0" class="errorTable">
      <tr>
        <td><?PHP echo $message; ?>&nbsp;</td>
      </tr>
    </table>
    <form action="rijndael.php" method="post" enctype="multipart/form-data">
    <table width="100%"  border="0" cellspacing="0" cellpadding="3"  class="text">
      <tr>
        <td>Infotext:</td>
        <td><input name="info" type="text" id="info" class="inputField" value="<?PHP echo $_POST['info']; ?>"></td>
      </tr>
	  <tr>
        <td width="22%">Verschl&uuml;sselung:</td>
        <td width="78%"><select name="rijndael" id="rijndael" class="inputField">
          <option value="128" <?PHP if($_POST['rijndael'] == 128) echo 'selected'; ?>>128 Bit</option>
          <option value="192" <?PHP if($_POST['rijndael'] == 192) echo 'selected'; ?>>192 Bit</option>
          <option value="256" <?PHP if($_POST['rijndael'] == 256) echo 'selected'; ?>>256 Bit</option>
        </select></td>
      </tr>
	  <tr>
        <td>Typ:</td>
        <td><select name="typ" id="typ" class="inputField">
          <option value="1" <?PHP if($_POST['typ'] == 1) echo 'selected'; ?>>Text verschlsseln</option>
          <option value="2" <?PHP if($_POST['typ'] == 2) echo 'selected'; ?>>Datei verschlsseln</option>
        </select></td>
      </tr>
      <tr>
        <td>Passwort:</td>
        <td><input name="password" type="password" id="password" class="inputField"></td>
      </tr>
      <tr>
        <td>Passwort wiederholen:</td>
        <td><input name="passwordCheck" type="password" id="passwordCheck" class="inputField"></td>
      </tr>
      <tr>
        <td>Datei:</td>
        <td><input type="file" name="file"  class="File"></td>
      </tr>
	  <tr>
        <td>Text:</td>
        <td><textarea name="textfield" rows="6" class="Textfiled"><?PHP echo $_POST['textfield']; ?></textarea></td>
	  </tr>
	   <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
	   </tr>
	   <tr>
        <td>&nbsp;</td>
        <td><input type="submit" name="Submit" value="Daten verschl&uuml;sseln" class="SendButton"></td>
	   </tr>
    </table>
	</form>
    <p>&nbsp;</p>
  </div> 
  
</div> 
<!--end content --> 
<div id="siteInfo"> 
  &copy;2006 by SELFPHP
</div> 
<br> 
</body>
</html>
